#define TITLE "TwitKill"
#define VERSION "1.05"

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <ctype.h>
#include <dir.h>
#include <dos.h>
#include <msgapi.h>
#include <prog.h>

struct AREAS
{
	char p[MAXPATH];
	int t;
} huge *area;

struct TWITS
{
	char n[36];
	char d;
} far *twits;

struct TAGS
{
	char n[25];
} huge *tags;

int areas, twit_cnt, twits_fnd;
int echo_flag=1, net_flag, loc_flag, pass_flag;
FILE *log;
char temp[128];
char month[12][4]={"Jan", "Feb", "Mar", "Apr", "May", "Jun",
                   "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};

void log_it(char type, char *text)
{
struct date dd;
struct time tt;

	if(log==NULL)
		return;

	getdate(&dd);
	gettime(&tt);
	fprintf(log, "%c %02d %s %02d:%02d:%02d TWKL %s\n",
		type, dd.da_day, month[dd.da_mon-1],
		tt.ti_hour, tt.ti_min, tt.ti_sec, text);
}

void near terminate(int code)
{
	if(area!=NULL)
		farfree(area);

	if(twits!=NULL)
		farfree(twits);

	if(tags!=NULL)
		farfree(tags);

	sprintf(temp, "End.  %d messages killed", twits_fnd);
	log_it('+', temp);
	fclose(log);
	exit(code);
}

static char * near KillrCatFight(XMSG *msg, char *dir)
{
int sr;

	for(sr=0; sr<twit_cnt; sr++)
	{
		if((twits[sr].d=='F'||twits[sr].d=='B')&&!stricmp(msg->from, twits[sr].n))
		{
			strcpy(dir, "From");
			return msg->from;
		}

		if((twits[sr].d=='T'||twits[sr].d=='B')&&!stricmp(msg->to, twits[sr].n))
		{
			strcpy(dir, "To");
			return msg->to;
		}
	}

	return NULL;
}

static void near KillrCatStalkPrey(HAREA harea, char *tag)
{
char *txt, *found, dir[6];
HMSG hmsg;
XMSG msg;
long mn;

	for(mn=1; (dword)mn<=MsgGetHighMsg(harea); mn++)
	{
		if((hmsg=MsgOpenMsg(harea, MOPEN_READ, mn))==NULL)
			continue;

		if((txt=malloc((size_t)MsgGetTextLen(hmsg)))!=NULL)
		{
			MsgReadMsg(hmsg, &msg, 0L, MsgGetTextLen(hmsg), txt, 0L, NULL);

			if((found=KillrCatFight(&msg, dir))!=NULL)
			{
				MsgCloseMsg(hmsg);
				MsgKillMsg(harea, mn);
			    sprintf(temp, "(%s #%ld) %s \"%s\"", tag, mn, dir, found);
				log_it(':', temp);
		    	fprintf(stdout, "   Kill #%ld - %s \"%s\"\n", mn, dir, found);
				twits_fnd++;
			}

			free(txt);

			if(found)
			{
				mn--;
				continue;
			}
		}

		MsgCloseMsg(hmsg);
	}
}

static void near KillrCatPounce(int num)
{
HAREA harea;

	if((harea=MsgOpenArea(area[num].p, MSGAREA_NORMAL, area[num].t))==NULL)
	{
		fprintf(stderr, "Can't open message area \"%s\"\n", area[num].p);
		return;
	}

	fprintf(stdout, "Scanning %s\n", area[num].p);
	MsgLock(harea);
	KillrCatStalkPrey(harea, area[num].p);
	MsgCloseArea(harea);
}

char * near kill_white(char *string)
{
char *ptr;

	ptr=string;

	while(*ptr==' ' || *ptr=='\t')
		ptr++;

	return ptr;
}

char * near nextword(char *text)
{
char *chr;

	chr=text;

	for(; chr; chr++)
		if(*chr==' ' || *chr=='\t' || *chr==0)
			break;

	if(*chr)
	{
		*chr++=0;
		chr=kill_white(chr);
	}

	return chr;
}

int near read_cfg(char *cfg_name, int log_cnt)
{
FILE *filenum;
char *ptr, *base, *tag;
char buffer[1025];
int passthru, pass=2, cnt;

	while(pass)
	{
		areas=0;

		if((filenum=fopen(cfg_name, "rt"))==NULL)
		{
			fprintf(stderr, "Error opening \"%s\"\n", cfg_name);
			return 0;
		}

		while(fgets(buffer, sizeof(buffer), filenum)!=NULL)
		{
			if((ptr=strchr(buffer, '\n'))!=NULL)
				*ptr=0;

			ptr=kill_white(strupr(buffer));

			if(*ptr==';' || !*ptr)
				continue;

			tag=nextword(ptr);


			if(!strcmp(ptr, "LOGFILE")&&log==NULL)
			{
				log=fopen(tag, "a");
				fprintf(log, "\n");
				log_it('+', "Begin, " TITLE " " VERSION);
			}

			if((!strcmp(ptr, "ECHOAREA")&&echo_flag)
				||(!strcmp(ptr, "LOCALAREA")&&loc_flag)
				||(!strcmp(ptr, "NETAREA")&&net_flag))
			{
				if(pass==1)
					area[areas].t=MSGTYPE_SDM;

				base=nextword(tag);
				ptr=nextword(base);
				passthru=log_cnt;

				if(log_cnt)
				{
					for(cnt=0; cnt<log_cnt; cnt++)
					{
						if(!strcmp(tag, tags[cnt].n))
						{
							passthru=0;
							break;
						}
					}
				}

				while(*ptr++=='-')
				{
					if(*ptr=='$'&&pass==1)
						area[areas].t=MSGTYPE_SQUISH;

					if(*ptr=='0'&&!pass_flag)
						passthru++;

					ptr=nextword(ptr);
				}

				if(!passthru)
				{
					if(pass==1)
						strncpy(area[areas].p, base, MAXPATH);

					areas++;
				}
			}
		}

		fclose(filenum);
		pass--;

		if(!areas)
		{
			fprintf(stderr, "No valid area definitions found\n");
			return 0;
		}

		if(pass==1&&(area=farmalloc((long)(areas+1)*(long)sizeof(struct AREAS)))==NULL)
		{
			fputs("Error allocating memory for area list\n", stderr);
			terminate(5);
		}
	}

	farfree(tags);
	return areas;
}

int near read_list(char *name)
{
FILE *filenum;
char buffer[512], line_text[512];
char *ptr, *buff;
int line, pass=2;

	while(pass)
	{
		line=twit_cnt=0;

		if((filenum=fopen(name, "rt"))==NULL)
		{
			fprintf(stderr, "Error opening \"%s\"\n", name);
			return 0;
		}

		while(fgets(buffer, sizeof(buffer), filenum)!=NULL)
		{
			line++;
			strcpy(line_text, buffer);

			if((ptr=strchr(buffer, '\n'))!=NULL)
				*ptr=0;

			buff=kill_white(buffer);

			if(!*buffer||*buff==';')
				continue;

			if((ptr=strchr(buff, ';'))!=NULL)
				*ptr=0;

			ptr=nextword(buff);

			while(isspace(ptr[strlen(ptr)-1]))
				ptr[strlen(ptr)-1]=0;

			if((stricmp(buff, "T")&&
				stricmp(buff, "F")&&
				stricmp(buff, "B"))||!*ptr)
			{
				fclose(filenum);
				fprintf(stderr, "Invalid line (%d) in \"%s\"\n", line, name);
				fputs(line_text, stderr);
				return 0;
			}

			if(pass==1)
			{
				twits[twit_cnt].d=toupper(*buff);
				strncpy(twits[twit_cnt].n, ptr, 35);
			}

			twit_cnt++;
		}

		fclose(filenum);
		pass--;

		if(!twit_cnt)
		{
			fprintf(stderr, "No valid twit definitions found\n");
			return 0;
		}

		if(pass==1&&(twits=farmalloc((long)(twit_cnt+1)*(long)sizeof(struct TWITS)))==NULL)
		{
			fputs("Error allocating memory for twits list\n", stderr);
			terminate(5);
		}
	}

	return twit_cnt;
}

int near read_log(char *name)
{
FILE *filenum;
char buffer[512];
char *ptr;
int cnt, pass=2;

	while(pass)
	{
		cnt=0;

		if((filenum=fopen(name, "rt"))==NULL)
		{
			fprintf(stderr, "Error opening \"%s\"\n", name);
			return 0;
		}

		while(fgets(buffer, sizeof(buffer), filenum)!=NULL)
		{
			if(pass==1)
			{
				if((ptr=strchr(buffer, '\n'))!=NULL)
					*ptr=0;

				ptr=kill_white(strupr(buffer));

				while(isspace(ptr[strlen(ptr)-1]))
					ptr[strlen(ptr)-1]=0;

				strcpy(tags[cnt].n, ptr);
			}

			cnt++;
		}

		fclose(filenum);
		pass--;

		if(!cnt)
		{
			fprintf(stderr, "The toss log appears to be empty\n");
			return 0;
		}

		if(pass==1&&(tags=farmalloc((long)(cnt+1)*(long)sizeof(struct TAGS)))==NULL)
		{
			fputs("Error allocating memory for toss log\n", stderr);
			terminate(5);
		}
	}

	return cnt;
}

void near syntax(void)
{
	fputs("\n" TITLE " " VERSION ", Global twit filter for Squish.\n\n", stderr);
	fputs("Syntax: " TITLE " [/E[+]] [/L[+]] [/N[+]] [/P[+]] [/Utoss.log] [twit_list]\n\n", stderr);
	fputs("/E          Filter echo areas (+ = yes)\n", stderr);
	fputs("/L          Filter local areas (+ = yes)\n", stderr);
	fputs("/N          Filter netmail areas (+ = yes)\n", stderr);
	fputs("/P          Filter passthrough areas (+ = yes)\n", stderr);
	fputs("/Utoss.log  Filter only the areas in toss.log\n", stderr);
	fputs("twit_list   Specify a list of twits\n\n", stderr);
	fputs("The default is filter non-passthrough echos only\n", stderr);
}

int _stdc main(int argc, char **argv)
{
char drive[MAXDRIVE], dir[MAXDIR], nam[MAXFILE], ext[MAXEXT];
char twit_list[MAXPATH], cfg_name[MAXPATH], log_name[MAXPATH];
struct _minf mi;
int cnt=0;

	*log_name=0;
	area=NULL;
	twits=NULL;
	tags=NULL;
	fprintf(stdout, "\n" TITLE " " VERSION ", Global twit filter for Squish.\n\n");
	fnsplit(argv[0], drive, dir, nam, ext);
	fnmerge(twit_list, drive, dir, nam, ".twt");

	while(--argc)
	{
		argv++;

		if(isalnum(**argv))
			strcpy(twit_list, *argv);

		if(**argv=='/'||**argv=='-')
		{
			switch(toupper(*(*argv+1)))
			{
				case '?':
					syntax();
					return 0;

				case 'E':
					echo_flag=(*(*argv+2)=='+')?1:0;
					break;

				case 'L':
					loc_flag=(*(*argv+2)=='+')?1:0;
					break;

				case 'N':
					net_flag=(*(*argv+2)=='+')?1:0;
					break;

				case 'P':
					pass_flag=(*(*argv+2)=='+')?1:0;
					break;

				case 'U':
					strcpy(log_name, *argv+2);
					break;
			}

			continue;
		}
	}

	if(*log_name)
	{
		cnt=read_log(log_name);

		if(!cnt)
			terminate(1);
	}

	strcpy(cfg_name, getenv("SQUISH"));

	if(*cfg_name)
		if(cfg_name[strlen(cfg_name)-1]=='\\')
			strcat(cfg_name, "\\squish.cfg");

	else
		strcpy(cfg_name, searchpath("squish.cfg"));

	if(!read_cfg(cfg_name, cnt))
		terminate(2);

	if(!read_list(twit_list))
		terminate(3);

	memset(&mi, '\0', sizeof mi);
	mi.req_version=MSGAPI_VERSION;

	if(MsgOpenApi(&mi))
	{
		fprintf(stderr, "Error initialising MSGAPI\n");
		terminate(4);
	}

	for(cnt=0; cnt<areas; cnt++)
		KillrCatPounce(cnt);

	fprintf(stdout, "\n%d messages killed\n", twits_fnd);
	MsgCloseApi();
	terminate(0);
	return 0;
}
